package blackopsPSG1imageSwitch
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 4 && %val)
		{
			if(%obj.getMountedImage(0) == blackopsPSG1Image.getID())
			{
				%obj.updateArm(blackopsPSG1scopedImage);
				%obj.mountImage(blackopsPSG1scopedImage,0);
				%obj.changeDatablock($weapondata::PSG1::scopedatablock);
				%obj.client.setControlCameraFov(6);
				
			}
			else if(%obj.getMountedImage(0) == blackopsPSG1scopedImage.getID())
			{
				%obj.updateArm(blackopsPSG1scopedImage);
				%obj.mountImage(blackopsPSG1Image,0);
				%obj.changeDatablock(datablocktouse(%obj.client));
				%obj.client.setControlCameraFov(90);
			}
		}
	}
	
	function servercmdlight(%client)
	{
		if(isObject(%client.player))
		{
			if(isObject(%client.player.getMountedImage(0)))
			{
				%gun = %client.player.getMountedImage(0);
				%guntype = %gun.getName();
				if((%guntype $= "blackopsPSG1Image" || %guntype $= "blackopsPSG1scopedImage") && %client.PSG1ammo < $weapondata::PSG1::magsize)
				{
					%client.player.wannareload=true;
					%client.player.setImageAmmo(0,0);
					return;
				}
			}
		}
		Parent::servercmdlight(%client);
	}
};
activatePackage(blackopsPSG1imageSwitch);

datablock ItemData(blackopsPSG1Item)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./PSG1.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "PSG1";
	image = blackopsPSG1Image;
	canDrop = true;
};

datablock ShapeBaseImageData(blackopsPSG1Image)
{
   // Basic Item properties
   shapeFile = "./PSG1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsPSG1Item;
   ammo = " ";
   projectile = syjguncProjectile;
   projectileType = Projectile;

   casing = gunShell762Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = $weapondata::PSG1::firerate;
	stateTransitionOnTimeout[2]	="Reload";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.001;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";
	stateAllowImageChange[5]         = true;

	stateAllowImageChange[6]         = true;
	stateName[6] = "Filler";
	stateTimeoutValue[6] = $weapondata::PSG1::reloadtime;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateSequence[6] = "Reload";
};

function blackopsPSG1Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.sniperammo < 0)
		%obj.client.sniperammo = 0;
	%client = %obj.client;
	if(!(%client.PSG1ammo > 0) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsPSG1Image::Reloading(%this,%obj,%slot)
{
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);
	if(%obj.client.sniperammo < 1)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = $weapondata::PSG1::magsize-%obj.client.PSG1ammo;
	%obj.client.sniperammo -= %difference;
	%obj.client.PSG1ammo = $weapondata::PSG1::magsize;
	if(%obj.client.sniperammo < 0)
		%obj.client.sniperammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);
	//%obj.playThread(2,shiftright);
	%obj.setImageAmmo(%slot,true);
}

function blackopsPSG1Image::onFire(%this,%obj,%that)
{
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);

	if($weapondata::PSG1::needsscope)
		commandtoclient(%obj.client,'centerPrint',"This weapon must be scoped in to fire.",5);
	else
	{

	%projectile = $weapondata::PSG1::projectile;
	%spread = $weapondata::PSG1::spreada;
	%shellcount = $weapondata::PSG1::shellcount;

	for(%a=0;%a<%shellcount;%a++)
	{

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	}

	%obj.client.PSG1ammo--;

	}
}


datablock ShapeBaseImageData(blackopsPSG1scopedImage)
{
   // Basic Item properties
   shapeFile = "./scope.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset=$weapondata::PSG1::eyeoffset;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsPSG1Item;
   ammo = " ";
   projectile = hdsyjguncProjectile;
   projectileType = Projectile;

   casing = gunShell762Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = $weapondata::PSG1::firerate;
	stateTransitionOnTimeout[2]	="Reload";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= blackopssniperfireSound;
	stateEjectShell[2]       = true;
	stateEjectShell[8]       = true;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.001;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";
	stateAllowImageChange[5]         = true;

	stateName[6] = "Filler";
	stateTimeoutValue[6] = $weapondata::PSG1::reloadtime;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateAllowImageChange[6]         = true;
};

function blackopsPSG1scopedImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.sniperammo < 0)
		%obj.client.sniperammo = 0;
	%client = %obj.client;
	if(!(%client.PSG1ammo > 0) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsPSG1scopedImage::Reloading(%this,%obj,%slot)
{
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);
	if(%obj.client.sniperammo < 1)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = $weapondata::PSG1::magsize-%obj.client.PSG1ammo;
	%obj.client.sniperammo -= %difference;
	%obj.client.PSG1ammo = $weapondata::PSG1::magsize;
	if(%obj.client.sniperammo < 0)
		%obj.client.sniperammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);
	%obj.playThread(2,shiftright);
	%obj.setImageAmmo(%slot,true);
}

function blackopsPSG1scopedImage::onFire(%this,%obj,%slot)
{
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.PSG1ammo @ "/" @ %obj.client.sniperammo,1);

	%projectile = $weapondata::PSG1::projectile;
	%spread = $weapondata::PSG1::spreadb;
	%shellcount = $weapondata::PSG1::shellcount;

	for(%a=0;%a<%shellcount;%a++)
	{

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	}

	%obj.client.PSG1ammo--;
}
