package blackopsAK74imageSwitch
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 4 && %val)
		{
			if(%obj.getMountedImage(0) == blackopsAK74Image.getID())
			{
				%obj.updateArm(blackopsAK74scopedImage);
				%obj.mountImage(blackopsAK74scopedImage,0);
				%obj.changeDatablock($weapondata::AK74::scopedatablock);
				
			}
			else if(%obj.getMountedImage(0) == blackopsAK74scopedImage.getID())
			{
				%obj.updateArm(blackopsAK74scopedImage);
				%obj.mountImage(blackopsAK74Image,0);
				%obj.changeDatablock(datablocktouse(%obj.client));
			}
		}
	}
	
	function servercmdlight(%client)
	{
		if(isObject(%client.player))
		{
			if(isObject(%client.player.getMountedImage(0)))
			{
				%gun = %client.player.getMountedImage(0);
				%guntype = %gun.getName();
				if((%guntype $= "blackopsAK74Image" || %guntype $= "blackopsAK74scopedImage") && %client.ak74ammo < $weapondata::AK74::magsize)
				{
					%client.player.wannareload=true;
					%client.player.setImageAmmo(0,0);
					return;
				}
			}
		}
		Parent::servercmdlight(%client);
	}
};
activatePackage(blackopsAK74imageSwitch);

datablock ItemData(blackopsAK74Item)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./AK74.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "AK74";
	image = blackopsAK74Image;
	canDrop = true;
};

datablock ShapeBaseImageData(blackopsAK74Image)
{
   // Basic Item properties
   shapeFile = "./AK74.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsAK74Item;
   ammo = " ";
   projectile = syjguncProjectile;
   projectileType = Projectile;

   casing = gunShell556Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = $weapondata::AK74::firerate;
	stateTransitionOnTimeout[2]	="Ready";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= blackopsfastshotSound;
	stateEjectShell[2]       = true;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.001;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";

	stateName[6] = "Filler";
	stateTimeoutValue[6] = $weapondata::AK74::reloadtime;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateSequence[6] = "Reload";
};

function blackopsAK74Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);
	
	%client = %obj.client;
	if(!(%client.AK74ammo > 0) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsAK74Image::Reloading(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 1)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = $weapondata::AK74::magsize-%obj.client.AK74ammo;
	%obj.client.fastammo -= %difference;
	%obj.client.AK74ammo = $weapondata::AK74::magsize;
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);
	//%obj.playThread(2,shiftright);
	%obj.setImageAmmo(%slot,true);
}

function blackopsAK74Image::onFire(%this,%obj,%that)
{
	if($weapondata::AK74::needsscope)
		commandtoclient(%obj.client,'centerPrint',"This weapon must be scoped in to fire.",5);
	else
	{

	%projectile = $weapondata::AK74::projectile;
	%spread = $weapondata::AK74::spreada;
	%shellcount = $weapondata::AK74::shellcount;

	for(%a=0;%a<%shellcount;%a++)
	{

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	}

	%obj.client.AK74ammo--;

	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);

	}
}


datablock ShapeBaseImageData(blackopsAK74scopedImage)
{
   // Basic Item properties
   shapeFile = "./AK74.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset=$weapondata::AK74::eyeoffset;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsAK74Item;
   ammo = " ";
   projectile = syjguncProjectile;
   projectileType = Projectile;

   casing = gunShell556Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = $weapondata::AK74::firerate;
	stateTransitionOnTimeout[2]	="Ready";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= blackopsfastshotSound;
	stateEjectShell[2]       = true;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.001;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";

	stateName[6] = "Filler";
	stateTimeoutValue[6] = $weapondata::AK74::reloadtime;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateSequence[6] = "Reload";
};

function blackopsAK74scopedImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);
	
	%client = %obj.client;
	if(!(%client.AK74ammo > 0) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsAK74scopedImage::Reloading(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 1)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = $weapondata::AK74::magsize-%obj.client.AK74ammo;
	%obj.client.fastammo -= %difference;
	%obj.client.AK74ammo = $weapondata::AK74::magsize;
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);
	//%obj.playThread(2,shiftright);
	%obj.setImageAmmo(%slot,true);
}

function blackopsAK74scopedImage::onFire(%this,%obj,%slot)
{
	%projectile = $weapondata::AK74::projectile;
	%spread = $weapondata::AK74::spreadb;
	%shellcount = $weapondata::AK74::shellcount;

	for(%a=0;%a<%shellcount;%a++)
	{

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	}

	%obj.client.AK74ammo--;

	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.AK74ammo @ "/" @ %obj.client.fastammo,1);
}
