datablock TSShapeConstructor(blackopsc4Dts)
{
	baseShape  = "./c4.dts";
	sequence0  = "./c4.dsq root";
	sequence1  = "./c4.dsq run";
	sequence2  = "./c4.dsq walk";
	sequence3  = "./c4.dsq back";
	sequence4  = "./c4.dsq side";
	sequence5  = "./c4.dsq crouch";
	sequence6  = "./c4.dsq crouchRun";
	sequence7  = "./c4.dsq crouchBack";
	sequence8  = "./c4.dsq crouchSide";
	sequence9  = "./c4.dsq look";
	sequence10 = "./c4.dsq headside";
	sequence11 = "./c4.dsq headUp";
	sequence12 = "./c4.dsq jump";
	sequence13 = "./c4.dsq standjump";
	sequence14 = "./c4.dsq fall";
	sequence15 = "./c4.dsq land";
	sequence16 = "./c4.dsq armAttack";
	sequence17 = "./c4.dsq armReadyLeft";
	sequence18 = "./c4.dsq armReadyRight";
	sequence19 = "./c4.dsq armReadyBoth";
	sequence20 = "./c4.dsq spearready";  
	sequence21 = "./c4.dsq spearThrow";
	sequence22 = "./c4.dsq talk";  
	sequence23 = "./c4.dsq death1"; 
	sequence24 = "./c4.dsq shiftUp";
	sequence25 = "./c4.dsq shiftDown";
	sequence26 = "./c4.dsq shiftAway";
	sequence27 = "./c4.dsq shiftTo";
	sequence28 = "./c4.dsq shiftLeft";
	sequence29 = "./c4.dsq shiftRight";
	sequence30 = "./c4.dsq rotCW";
	sequence31 = "./c4.dsq rotCCW";
	sequence32 = "./c4.dsq undo";
	sequence33 = "./c4.dsq plant";
	sequence34 = "./c4.dsq sit";
	sequence35 = "./c4.dsq wrench";
  	sequence36 = "./c4.dsq activate";
  	sequence37 = "./c4.dsq activate2";
  	sequence38 = "./c4.dsq leftrecoil";
}; 

datablock PlayerData(Playerblackopsc4 : PlayerStandardArmor)
{
	shapeFile = "./c4.dts";
	maxDamage = 150;
	boundingBox = "0.1 0.1 0.1";
  	thirdPersonOnly = 0;
	mass = 470;
	canJet = 0;
	uiName = "";
	maxForwardSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxBackwardSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpForce = 0;
};

datablock ItemData(blackopsc4Item)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./c4.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "C4 (bomw)";
	image = blackopsc4Image;
	canDrop = true;
	iconName = "./c4icon";
};

datablock ShapeBaseImageData(blackopsc4Image)
{
   shapeFile = "./c4.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; 
   rotation = eulerToMatrix( "0 0 10" );  
   correctMuzzleVector = true;
   className = "WeaponImage";
   melee = false;
   armReady = true;
   item = blackopsc4Item;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

};

datablock ItemData(blackopsdetonatorItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./detonator.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	image = blackopsdetonatorImage;
	canDrop = false;
};

datablock ShapeBaseImageData(blackopsdetonatorImage)
{
   shapeFile = "./detonator.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; 
   rotation = eulerToMatrix( "0 0 10" );  
   correctMuzzleVector = true;
   className = "WeaponImage";
   melee = false;
   armReady = true;
   item = blackopsdetonatorItem;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

};

function blackopsc4Image::onFire(%this,%obj,%slot)
{
	%client = %obj.client;
	
	if(isObject(%client.c4))
	{
		messageclient(%client,'',"You already have c4 planted!");
		return;
	}

	%client.c4 = new AiPlayer()
	{
		datablock = "Playerblackopsc4";
		position = %client.player.position;
	};
	MissionCleanup.add(%client.c4);
	%client.c4.settransform(%client.player.gettransform());

	serverCmdUnUseTool(%client);

	for(%a=0;%a<5;%a++)
	{
		if(isObject(%client.player.tool[%a]))
		{
			if(%client.player.tool[%a].getname() $= "blackopsc4Item")
			{
				%client.player.tool[%a] = blackopsdetonatorItem.getID();
				messageclient(%client,'MsgItemPickup','',%a,blackopsdetonatorItem.getID());
			}
		}
	}	
}

function blackopsdetonatorImage::onFire(%this,%obj,%slot)
{
	%client = %obj.client;

	serverCmdUnUseTool(%client);

	for(%a=0;%a<5;%a++)
	{
		if(isObject(%client.player.tool[%a]))
		{
			if(%client.player.tool[%a].getname() $= "blackopsdetonatorItem")
			{
				%client.player.tool[%a] = 0;
				messageclient(%client,'MsgItemPickup','',%a,0);
			}
		}
	}

	if(!isObject(%client.c4))
		return;

	%p = new Projectile()
	{
		dataBlock = "blackopsbombtempProjectile";
		initialPosition = %client.c4.position;
		position = %client.c4.position;
		initialVelocity = "0 0 0";
		client = %client;
	};

	%client.c4.delete();
}

package blackopsc4
{
	function GameConnection::onDeath(%a,%b,%c,%d,%e)
	{
		Parent::onDeath(%a,%b,%c,%d,%e);
		
		%client = %a;

		if(isObject(%client.c4))
			%client.c4.delete();
	}
};
activatepackage(blackopsc4);