datablock PathCameraData(blackopsCam)
{
	cameraMaxDist = 0;
	cameraMinDist = 0;
	cameraDefaultFov = 90;
	cameraMinFov = 10;
	cameraMaxFov = 150;
};

datablock TSShapeConstructor(blackopscameraDts)
{
	baseShape  = "./camera.dts";
	sequence0  = "./camera.dsq root";
	sequence1  = "./camera.dsq run";
	sequence2  = "./camera.dsq walk";
	sequence3  = "./camera.dsq back";
	sequence4  = "./camera.dsq side";
	sequence5  = "./camera.dsq crouch";
	sequence6  = "./camera.dsq crouchRun";
	sequence7  = "./camera.dsq crouchBack";
	sequence8  = "./camera.dsq crouchSide";
	sequence9  = "./camera.dsq look";
	sequence10 = "./camera.dsq headside";
	sequence11 = "./camera.dsq headUp";
	sequence12 = "./camera.dsq jump";
	sequence13 = "./camera.dsq standjump";
	sequence14 = "./camera.dsq fall";
	sequence15 = "./camera.dsq land";
	sequence16 = "./camera.dsq armAttack";
	sequence17 = "./camera.dsq armReadyLeft";
	sequence18 = "./camera.dsq armReadyRight";
	sequence19 = "./camera.dsq armReadyBoth";
	sequence20 = "./camera.dsq spearready";  
	sequence21 = "./camera.dsq spearThrow";
	sequence22 = "./camera.dsq talk";  
	sequence23 = "./camera.dsq death1"; 
	sequence24 = "./camera.dsq shiftUp";
	sequence25 = "./camera.dsq shiftDown";
	sequence26 = "./camera.dsq shiftAway";
	sequence27 = "./camera.dsq shiftTo";
	sequence28 = "./camera.dsq shiftLeft";
	sequence29 = "./camera.dsq shiftRight";
	sequence30 = "./camera.dsq rotCW";
	sequence31 = "./camera.dsq rotCCW";
	sequence32 = "./camera.dsq undo";
	sequence33 = "./camera.dsq plant";
	sequence34 = "./camera.dsq sit";
	sequence35 = "./camera.dsq wrench";
  	sequence36 = "./camera.dsq activate";
  	sequence37 = "./camera.dsq activate2";
  	sequence38 = "./camera.dsq leftrecoil";
}; 

datablock PlayerData(Playerblackopscamera : PlayerStandardArmor)
{
	shapeFile = "./camera.dts";
	maxDamage = 150;
	boundingBox = "0.1 0.1 0.1";
  	thirdPersonOnly = 0;
	mass = 470;
	canJet = 0;
	uiName = "";
	maxForwardSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxBackwardSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpForce = 0;
};

datablock ItemData(blackopscameraItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./camera.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Camera";
	image = blackopscameraImage;
	canDrop = true;
	iconName = "./cameraicon";
};

datablock ShapeBaseImageData(blackopscameraImage)
{
   shapeFile = "./camera.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; 
   rotation = eulerToMatrix( "0 0 10" );  
   correctMuzzleVector = true;
   className = "WeaponImage";
   melee = false;
   armReady = true;
   item = blackopscameraItem;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

};

datablock ItemData(blackopsremoteItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./remote.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	image = blackopsremoteImage;
	canDrop = false;
};

datablock ShapeBaseImageData(blackopsremoteImage)
{
   shapeFile = "./remote.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; 
   rotation = eulerToMatrix( "0 0 10" );  
   correctMuzzleVector = true;
   className = "WeaponImage";
   melee = false;
   armReady = true;
   item = blackopsremoteItem;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

};

function blackopscameraImage::onFire(%this, %obj, %slot)
{
	%client = %obj.client;

	if(isObject(%client.bocamera))
	{
		messageclient(%client,'',"You already have a camera set up, remove it first.");
		return;
	}

	%client.bocamera = new AiPlayer()
	{
		datablock = "Playerblackopscamera";
		position = %client.player.position;
		rotation = %client.player.rotation;
	};	
	%client.bocamera.settransform(%client.player.gettransform());
	MissionCleanup.add(%client.bocamera);

	serverCmdUnUseTool(%client);

	for(%a=0;%a<5;%a++)
	{
		if(isObject(%client.player.tool[%a]))
		{
			if(%client.player.tool[%a].getname() $= "blackopscameraItem")
			{
				%client.player.tool[%a] = blackopsremoteItem.getid();
				messageclient(%client,'MsgItemPickup','',%a,blackopsremoteItem.getid());
			}
		}
	}	

	%client.remotedebuf=true;
	schedule(1000,0,unremotedebuf,%client);

	messageclient(%client,'',"Left click remote to see out of the camera!");
	messageclient(%client,'',"Right click remote to pick up your camera.");
}

function heightenvector(%vec,%amount)
{
	return getword(%vec,0) SPC getword(%vec,1) SPC getword(%vec,2)+%amount;
}

function servercmdcam(%a)
{
	if(!isObject(%a.bocamera))
	{
		messageclient(%a,'',"You have no camera set up to use!");
		return;
	}

	if(isObject(%a.caming))
		%a.delete();

	%cam = new PathCamera()
	{
		dataBlock = blackopsCam;
		position = heightenvector(%a.bocamera.position,0.5);
		rotation = %a.bocamera.rotation;
	};

	%a.caming = %cam;
	%a.setcontrolobject(%cam);
	missioncleanup.add(%cam);

	messageclient(%a,'',"One moment...");
	messageclient(%a,'',"You can use the light key to return to normal.");
}

function servercmdremovecamera(%a)
{
	if(!isObject(%a.bocamera))
	{
		messageclient(%a,'',"You have no camera to remove!");
		return;
	}
	else
	{
		%a.bocamera.delete();
		%a.bocamera = -1;
	}

	%client = %a;

	serverCmdUnUseTool(%client);
 
	for(%a=0;%a<5;%a++)
	{
		if(isObject(%client.player.tool[%a]))
		{
			echo(%client.player.tool[%a].getname());
			if(%client.player.tool[%a].getname() $= "blackopsremoteItem")
			{
				%client.player.tool[%a] = blackopscameraItem.getID();
				messageclient(%client,'MsgItemPickup','',%a,blackopscameraItem.getID());
			}
		}
	}
}

function unremotedebuf(%a)
{
	%a.remotedebuf = false;
}

package blackopscamera
{
	function GameConnection::onDeath(%a,%b,%c,%d,%e)
	{
		%client = %a;

		if(isObject(%client.caming))
			%client.caming.delete();
		%client.caming = -1; 
		if(isObject(%client.bocamera))
			%client.bocamera.delete();
		%client.bocamera = -1;

		Parent::onDeath(%a,%b,%c,%d,%e);

		if(isObject(%client.caming))
			%client.caming.delete();
		%client.caming = -1; 
		if(isObject(%client.bocamera))
			%client.bocamera.delete();
		%client.bocamera = -1;
	}

	function serverCmdLight(%client)
	{
		if(isObject(%client.caming))
		{
			%client.caming.delete();
			%client.caming = -1;
			%client.setControlObject(%client.player);
			schedule(1000,0,servercmdlight,%client);
		}
		else
			Parent::serverCmdLight(%client);
	}
	
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(isObject(%player.getMountedImage(0)))
		{
			if(%player.getMountedImage(0).getName() $= "blackopsremoteImage")
			{
				if(!%player.client.remotedebuf)
				{
					%player.client.remotedebuf=true;
					if(%slot == 0)
						servercmdcam(%player.client);
					else if(%slot == 4)
						servercmdremovecamera(%player.client);
					schedule(750,0,unremotedebuf,%player.client);
				}
				return;
			}
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}
};
activatepackage(blackopscamera);