datablock TSShapeConstructor(blackopsclaymoreDts)
{
	baseShape  = "./claymore.dts";
	sequence0  = "./claymore.dsq root";
	sequence1  = "./claymore.dsq run";
	sequence2  = "./claymore.dsq walk";
	sequence3  = "./claymore.dsq back";
	sequence4  = "./claymore.dsq side";
	sequence5  = "./claymore.dsq crouch";
	sequence6  = "./claymore.dsq crouchRun";
	sequence7  = "./claymore.dsq crouchBack";
	sequence8  = "./claymore.dsq crouchSide";
	sequence9  = "./claymore.dsq look";
	sequence10 = "./claymore.dsq headside";
	sequence11 = "./claymore.dsq headUp";
	sequence12 = "./claymore.dsq jump";
	sequence13 = "./claymore.dsq standjump";
	sequence14 = "./claymore.dsq fall";
	sequence15 = "./claymore.dsq land";
	sequence16 = "./claymore.dsq armAttack";
	sequence17 = "./claymore.dsq armReadyLeft";
	sequence18 = "./claymore.dsq armReadyRight";
	sequence19 = "./claymore.dsq armReadyBoth";
	sequence20 = "./claymore.dsq spearready";  
	sequence21 = "./claymore.dsq spearThrow";
	sequence22 = "./claymore.dsq talk";  
	sequence23 = "./claymore.dsq death1"; 
	sequence24 = "./claymore.dsq shiftUp";
	sequence25 = "./claymore.dsq shiftDown";
	sequence26 = "./claymore.dsq shiftAway";
	sequence27 = "./claymore.dsq shiftTo";
	sequence28 = "./claymore.dsq shiftLeft";
	sequence29 = "./claymore.dsq shiftRight";
	sequence30 = "./claymore.dsq rotCW";
	sequence31 = "./claymore.dsq rotCCW";
	sequence32 = "./claymore.dsq undo";
	sequence33 = "./claymore.dsq plant";
	sequence34 = "./claymore.dsq sit";
	sequence35 = "./claymore.dsq wrench";
  	sequence36 = "./claymore.dsq activate";
  	sequence37 = "./claymore.dsq activate2";
  	sequence38 = "./claymore.dsq leftrecoil";
}; 

datablock PlayerData(Playerblackopsclaymore : PlayerStandardArmor)
{
	shapeFile = "./claymore.dts";
	maxDamage = 150;
	boundingBox = "0.1 0.1 0.1";
  	thirdPersonOnly = 0;
	mass = 470;
	canJet = 0;
	uiName = "";
	maxForwardSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxBackwardSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxSideSpeed = 0;
	maxSideCrouchSpeed = 0;
	jumpForce = 0;
};

datablock ItemData(blackopsclaymoreItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./claymore.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "claymore";
	image = blackopsclaymoreImage;
	canDrop = true;
	iconName = "./claymoreicon";
};

datablock ShapeBaseImageData(blackopsclaymoreImage)
{
   shapeFile = "./claymore.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; 
   rotation = eulerToMatrix( "0 0 10" );  
   correctMuzzleVector = true;
   className = "WeaponImage";
   melee = false;
   armReady = true;
   item = blackopsclaymoreItem;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateScript[0]                  = "onActivate";
	stateSequence[0]                  = "Activate";

	stateName[1]                     = "Ready";
	stateScript[1]                  = "onUse";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerUp[2]	= "Ready";
	stateScript[2]                  = "onFire";

};

function blackopsclaymoreImage::onFire(%this,%obj,%slot)
{
	%client = %obj.client;
	
	if(isObject(%client.claymore))
	{
		messageclient(%client,'',"You already have claymore planted!");
		return;
	}

	%client.claymore = new AiPlayer()
	{
		datablock = "Playerblackopsclaymore";
		position = %client.player.position;
		shapeName = "Test";
	};
	MissionCleanup.add(%client.claymore);
	%client.claymore.settransform(%client.player.gettransform());

	serverCmdUnUseTool(%client);

	for(%a=0;%a<5;%a++)
	{
		if(isObject(%client.player.tool[%a]))
		{
			if(%client.player.tool[%a].getname() $= "blackopsclaymoreItem")
			{
				%client.player.tool[%a] = 0;
				messageclient(%client,'MsgItemPickup','',%a,0);
			}
		}
	}	
}

function claymorelogic()
{
	$claymorelogicloop = schedule(500,0,claymorelogic);

	for(%a=0;%a<clientgroup.getcount();%a++)
	{
		%client = clientgroup.getobject(%a);
		if(isObject(%client.player))
		{
			if(isObject(%client.claymore))
			{
				%claymore = %client.claymore;
				%mask = $TypeMasks::PlayerObjectType;
				%boxsize = "10 10 10";
				%position = %client.claymore.position;
				initContainerBoxSearch(%position, %boxSize, %mask);
				while(%searchObj = containerSearchNext())
				{
 				 	if(isObject(%searchObj) && %searchObj != %claymore)
					{
						if(%searchObj.dataBlock $= "Playerblackopscamera")
							return;
						if(%searchObj.dataBlock $= "Playerblackopsclaymore")
							return;
						if(%searchObj.dataBlock $= "Playerblackopsc4")
							return;

						if(%searchObj.client != %client)
						{
							if(%client.minigame.teamExists[0] == 1)
							{
								if(%client.tdmteam == %searchObj.client.tdmteam)
									return;

								%p = new Projectile()
								{
									dataBlock = "blackopsbombtempProjectile";
									initialPosition = %claymore.position;
									position = %claymore.position;
									initialVelocity = "0 0 0";
									client = %client;
								};

								%claymore.delete();							
							}
							else
							{
								%p = new Projectile()
								{
									dataBlock = "blackopsbombtempProjectile";
									initialPosition = %claymore.position;
									position = %claymore.position;
									initialVelocity = "0 0 0";
									client = %client;
								};

								%claymore.delete();
							}
						}
					}
				}
			}
		}
	}
}
if(!($claymorelogicloop > 0))
	claymorelogic();

package blackopsclaymore
{
	function GameConnection::onDeath(%a,%b,%c,%d,%e)
	{
		Parent::onDeath(%a,%b,%c,%d,%e);
		
		%client = %a;

		if(isObject(%client.claymore))
			%client.claymore.delete();
	}
};
activatepackage(blackopsclaymore);