package blackopsM16imageSwitch
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 4 && %val)
		{
			if(%obj.getMountedImage(0) == blackopsM16Image.getID())
			{
				%obj.updateArm(blackopsM16scopedImage);
				%obj.mountImage(blackopsM16scopedImage,0);
				%obj.changeDatablock(Playerblackopsscoped);
			}
			else if(%obj.getMountedImage(0) == blackopsM16scopedImage.getID())
			{
				%obj.updateArm(blackopsM16scopedImage);
				%obj.mountImage(blackopsM16Image,0);
				%obj.changeDatablock(datablocktouse(%obj.client));
			}
		}
	}

	function servercmdlight(%client)
	{
		if(isObject(%client.player))
		{
			if(isObject(%client.player.getMountedImage(0)))
			{
				%gun = %client.player.getMountedImage(0);
				%guntype = %gun.getName();
				if((%guntype $= "blackopsM16Image" || %guntype $= "blackopsM16scopedImage") && %client.M16ammo < 21)
				{
					%client.player.wannareload=true;
					%client.player.setImageAmmo(0,0);
					return;
				}
			}
		}
		Parent::servercmdlight(%client);
	}
};
activatePackage(blackopsM16imageSwitch);

datablock ItemData(blackopsM16Item)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./M16.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "M16";
	image = blackopsM16Image;
	canDrop = true;
};

datablock ShapeBaseImageData(blackopsM16Image)
{
   // Basic Item properties
   shapeFile = "./M16.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsM16Item;
   ammo = " ";
   projectile = syjguncProjectile;
   projectileType = Projectile;

   casing = gunShell556Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]	="Fireb";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= blackopsfastshotSound;
	stateEjectShell[2]       = true;

	stateName[7]                    = "Fireb";
	stateTimeoutValue[7]            = 0.01;
	stateTransitionOnTimeout[7]	="Firec";
	stateFire[7]                    = true;
	stateAllowImageChange[7]        = false;
	stateSequence[7]                = "Fire";
	stateScript[7]                  = "onFire";
	stateWaitForTimeout[7]			= true;
	stateSound[7]					= blackopsfastshotSound;
	stateEjectShell[7]       = true;

	stateName[8]                    = "Firec";
	stateTransitionOnTimeout[8]	="Ready";
	stateTimeoutValue[8]		= 0.3;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateSound[8]					= blackopsfastshotSound;
	stateEjectShell[8]       = true;

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.01;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";

	stateName[6] = "Filler";
	stateTimeoutValue[6] = 2.5;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateSequence[6] = "Reload";
};

function blackopsM16Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.M16ammo @ "/" @ %obj.client.fastammo,1);
	
	%client = %obj.client;
	if(!(%client.M16ammo > 2) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsM16Image::Reloading(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 3)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = 21-%obj.client.M16ammo;
	%obj.client.fastammo -= %difference;
	%obj.client.M16ammo = 21;
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.M16ammo @ "/" @ %obj.client.fastammo,1);
	%obj.setImageAmmo(%slot,true);
}

function blackopsM16Image::onFire(%this,%obj,%that)
{
	%projectile = syjguncProjectile;
	%spread = 0.003;
	%shellcount = 3;

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	%obj.client.M16ammo--;
}


datablock ShapeBaseImageData(blackopsM16scopedImage)
{
   // Basic Item properties
   shapeFile = "./M16.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset="0 1.5 -0.37";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopsM16Item;
   ammo = " ";
   projectile = syjguncProjectile;
   projectileType = Projectile;

   casing = gunShell556Debris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "LoadCheckA";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		 = "Ready";
	stateTransitionOnNoAmmo[1]	 = "LoadCheckA";

	stateName[2]                    = "Firea";
	stateTimeoutValue[2]            = 0.02;
	stateTransitionOnTimeout[2]	="Fireb";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= blackopsfastshotSound;
	stateEjectShell[2]       = true;

	stateName[7]                    = "Fireb";
	stateTimeoutValue[7]            = 0.02;
	stateTransitionOnTimeout[7]	="Firec";
	stateFire[7]                    = true;
	stateAllowImageChange[7]        = false;
	stateSequence[7]                = "Fire";
	stateScript[7]                  = "onFire";
	stateWaitForTimeout[7]			= true;
	stateSound[7]					= blackopsfastshotSound;
	stateEjectShell[7]       = true;

	stateName[8]                    = "Firec";
	stateTransitionOnTimeout[8]	="Ready";
	stateTimeoutValue[8]		= 0.3;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateSound[8]					= blackopsfastshotSound;
	stateEjectShell[8]       = true;

	stateName[4] = "LoadCheckA";
	stateScript[4] = "onLoadCheck";
	stateTimeoutValue[4] = 0.01;
	stateTransitionOnTimeout[4] = "LoadCheckB";
	
	stateName[5] = "LoadCheckB";
	stateTransitionOnAmmo[5] = "Firea";
	stateTransitionOnNoAmmo[5] = "Filler";

	stateName[6] = "Filler";
	stateTimeoutValue[6] = 2.5;
	stateScript[6] = "Reloading";
	stateTransitionOnTimeout[6] = "Ready";
	stateSequence[6] = "Reload";
};

function blackopsM16scopedImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.M16ammo @ "/" @ %obj.client.fastammo,1);
	
	%client = %obj.client;
	if(!(%client.M16ammo > 2) || %client.player.wannareload)
		%obj.setImageAmmo(%slot,false);
	else
		%obj.setImageAmmo(%slot,true);
	%client.player.wannareload=false;
}

function blackopsM16scopedImage::Reloading(%this,%obj,%slot)
{
	if(%obj.client.fastammo < 3)
		return;
	%obj.client.playSound(ReloadSound);
	%difference = 21-%obj.client.M16ammo;
	%obj.client.fastammo -= %difference;
	%obj.client.M16ammo = 21;
	if(%obj.client.fastammo < 0)
		%obj.client.fastammo = 0;
	commandtoclient(%obj.client,'bottomPrint',"Ammo: " @ %obj.client.M16ammo @ "/" @ %obj.client.fastammo,1);
	%obj.setImageAmmo(%slot,true);
}

function blackopsM16scopedImage::onFire(%this,%obj,%slot)
{
	%projectile = syjguncProjectile;
	%spread = 0.0005;
	%shellcount = 3;

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);

	%obj.client.M16ammo--;
}
