forceRequiredAddOn("Player_No_Jet");
//required, *and* should be fully available for use while using this pack

%error = forceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
    GunItem.uiName = "";
//gun is also required
//but some people may not want people to access it, so that is respected

%error = forceRequiredAddOn("Weapon_Rocket_Launcher");
if(%error == $Error::AddOn_Disabled)
    rocketLauncherItem.uiName = "";
//RL is also required
//but some people may not want people to access it, so that is respected

datablock DebrisData(gunShell556Debris)
{
	shapeFile = "./5.56x45mmCartridge.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock DebrisData(gunShell762Debris)
{
	shapeFile = "./7.62x39mmCartridge.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock DebrisData(gunShellshotgunDebris)
{
	shapeFile = "./ShotgunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock AudioProfile(blackopsfastshotSound)
{
   filename    = "./fastgunshot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopsslowshotSound)
{
   filename    = "./slowgunshot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopsBounceSound)
{
   filename    = "./hegrenadeBounce.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(blackopsFireSound)
{
   filename    = "./hegrenadeFire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ReloadSound)
{
   filename    = "./Reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopspythonFireSound)
{
   filename    = "./PythonFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopsRPGFireSound)
{
   filename    = "./RPGFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopsrpgloopSound)
{
   filename    = "./rpg_loop.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(blackopssniperFireSound)
{
   filename    = "./SniperFire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ReloadsniperSound)
{
   filename    = "./SniperReload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reloadm60Sound)
{
   filename    = "./M60Reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BulletFlySound)
{
   filename    = "./bulletfly.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(BlackOpsKnockExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.7 0.7 0.7";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(BlackOpsKnockProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= BlackOpsKnockExplosion;

};

datablock ProjectileData(syjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 15;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   sound = BulletFlySound;
   uiName = "SYJBO Bullet";
};

datablock ExplosionData(syjrocketExplosion : rocketExplosion)
{
   damageRadius = 12;
   radiusDamage = 400;

   impulseRadius = 12;
   impulseForce = 4000;
};

datablock ProjectileData(syjrpgProjectile)
{
   projectileShapeName = "./rpg7projectile.dts";
   directDamage        = 150;
   brickExplosionImpact = false;
   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   muzzleVelocity      = 150;
   velInheritFactor    = 1;
   explodeOnPlayerImpact = true;
   explodeOnDeath = true;
   armingDelay         = 00;
   lifetime            = 30000;
   fadeDelay           = 30000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;
   haslight = true;
   lightradius = 10;
   lightColor = "1 0.5 0 1";
   explosion = syjrocketExplosion;
   sound = blackopsrpgloopSound;
   uiName = "SYJBO RPG";
};


datablock ProjectileData(mpsyjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 25;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.4;
   sound = BulletFlySound;
   hasLight    = false;

   uiName = "SYJBO MP Bullet";
};

datablock ProjectileData(hdsyjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 70;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.25;
   sound = BulletFlySound;
   hasLight    = false;

   uiName = "SYJBO HD Bullet";
};

datablock ProjectileData(masssyjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 10;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;
   sound = BulletFlySound;
   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.4;

   hasLight    = false;

   uiName = "SYJBO mass Bullet";
};

datablock ProjectileData(psgsyjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 120;
   sound = BulletFlySound;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.4;

   hasLight    = false;
   uiName = "SYJBO psg Bullet";
};

datablock ProjectileData(pythonsyjguncProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 50;
   sound = BulletFlySound;
   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.25;
   hasLight    = false;

   uiName = "SYJBO PY Bullet";
};

//PlayerNoJet.firstpersononly=1;

datablock ExplosionData(blackopsbombExplosion : rocketExplosion)
{
   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "0.4 0.4 0.4";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 10;
   lightStartColor = "1 1 1";
   lightEndColor = "1 1 1";

   //impulse
   impulseRadius = 16;
   impulseForce =  1300;

   //radius damage
   damageRadius = 15;
   radiusDamage = 100;

};

datablock ProjectileData(blackopsbombtempProjectile)
{
   directDamage       = 0;
   impactImpulse      = 0;
   verticalImpulse    = 0;
   explosion          = blackopsbombExplosion;

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 00;
   velInheritFactor    = 0;
   explodeOnDeath = true;

   armingDelay         = 0; //4 second fuse 
   lifetime            = 100;
   fadeDelay           = 0;
   bounceElasticity    = 0.4;
   bounceFriction      = 0.3;
   isBallistic         = false;
   gravityMod = 0;

   hasLight = false;
};

function setweapondata(%name,%magsize,%needsscope,%spreada,%spreadb,%firerate,%projectile,%scopedatablock,%reloadtime,%eyeoffset,%shellcount)
{
	eval("$weapondata::" @ %name @ "::magsize = " @ %magsize @ ";");
	eval("$weapondata::" @ %name @ "::needsscope = " @ %needsscope @ ";");
	eval("$weapondata::" @ %name @ "::spreada = \"" @ %spreada @ "\";");
	eval("$weapondata::" @ %name @ "::spreadb = \"" @ %spreadb @ "\";");
	eval("$weapondata::" @ %name @ "::firerate = " @ %firerate @ ";");
	eval("$weapondata::" @ %name @ "::projectile = " @ %projectile @ ";");
	eval("$weapondata::" @ %name @ "::scopedatablock = " @ %scopedatablock @ ";");
	eval("$weapondata::" @ %name @ "::reloadtime = " @ %reloadtime @ ";");
	eval("$weapondata::" @ %name @ "::eyeoffset = \"" @ %eyeoffset @ "\";");
	eval("blackops" @ %name @ "scopedImage.eyeoffset=\""@%eyeoffset@"\";");
	eval("$weapondata::" @ %name @ "::shellcount = " @ %shellcount @ ";");
}

//Feel free to change this data if you don't like how the guns work by default:

setweapondata("AK74",30,false,0.004,0.0015,0.0923,"masssyjguncprojectile","Playerblackopsscoped",2,"0 1 0",1);
setweapondata("MP5K",30,false,0.004,0.001,0.08,"masssyjguncprojectile","Playerblackopsscoped",3,"0 1 0",1);
setweapondata("Skorpion",20,false,0.004,0.001,0.08,"masssyjguncprojectile","Playerblackopsscoped",3.2,"0 1 -0.35",1);
setweapondata("M60",100,true,0,0.001,0.11214,"masssyjguncprojectile","Playerblackopshardscoped",8,"0 1 0",1);
setweapondata("Uzi",32,false,0.004,0.001,0.064,"masssyjguncprojectile","Playerblackopsscoped",3.2,"0 1 -0.175",1);
setweapondata("Dragunov",10,true,0,0,1.9,"hdsyjguncprojectile","Playerblackopsscoped",2.9,"0 2 -0.325",1);
setweapondata("PSG1",5,true,0,0,1.9,"psgsyjguncprojectile","Playerblackopsscoped",2.9,"0 2 -0.325",1);
setweapondata("Stakeout",4,false,0.008,0.004,1,"syjguncprojectile","Playerblackopsscoped",3,"0.005 1 -0.49",8);
setweapondata("ASP",7,false,0.003,0.001,0.06,"mpsyjguncprojectile","Playerblackopsscoped",2,"0 1 -0.28",1);
setweapondata("Makarov",8,false,0.003,0.001,0.096,"mpsyjguncprojectile","Playerblackopsscoped",2,"0 1 -0.34",1);
setweapondata("Python",6,false,0.003,0.001,0.1,"pythonsyjguncprojectile","Playerblackopsscoped",2,"0 1 0",1);
setweapondata("RPG7",2,false,0.003,0.001,2,"syjrpgprojectile","Playerblackopsscoped",3,"0 1 0",1);

function datablocktouse(%client)
{
	if(!isObject(%client.minigame))
		return PlayerStandardArmor.getID();
	if(%client.minigame.teamExists[0] == 1)
	{
		%team = %client.tdmTeam;
		return %client.minigame.teamPlayerData[%team];
	}
	else
	{
		return %client.minigame.playerDataBlock;
	}
}

exec("./camera.cs");
exec("./tac.cs");
exec("./c4.cs");
exec("./claymore.cs");
exec("./willypete.cs");
exec("./frag.cs");
exec("./novagas.cs");
exec("./flashbang.cs");
//exec("./killstreakbase.cs");      //I may add rtb prefs for this, rather than outright disabling it
exec("./tomahawk.cs");
exec("./perksbase.cs");               //this was going to be disabled too, but I realized it had the player types in it
exec("./ballisticknife.cs");
//exec("./levelsystem.cs");           Feel free to enable this, I just figured people wouldn't care for it.
exec("./asp.cs");
exec("./skorp.cs");
exec("./makarov.cs");
exec("./m16.cs");
exec("./m60.cs");
exec("./Dragunov.cs");
exec("./ak74.cs");
exec("./Python.cs");
exec("./mp5k.cs");
exec("./Uzi.cs");
exec("./PSG1.cs");
exec("./stakeout.cs");
exec("./rpg7.cs");
exec("./medikit.cs");
exec("./ammokit.cs");

function servercmdmwextdisable(%client)   //in case you don't want people to be forced to use no jet player
{
	if(!(%client.isAdmin || %client.isSuperAdmin)) return;
	messageall('',"M.W. extensions disabled. Do not try to use the modern weapons pack.");
	deactivatepackage(blackopsreload);
}

function servercmdmwextenable(%client)   //and this is incase you want the weapons to work right
{
	if(!(%client.isAdmin || %client.isSuperAdmin)) return;
	messageall('',"M.W. extensions enabled. Modern weapons pack will work properly now.");
	activatepackage(blackopsreload);
}

package blackopsreload
{
	function servercmdusetool(%a,%b)
	{
		Parent::servercmdusetool(%a,%b);
		%a.player.changeDatablock(datablocktouse(%a));
		%a.setControlCameraFov(90);
	}
	function GameConnection::createplayer(%a,%b)
	{
		Parent::createplayer(%a,%b);
		%a.AK74ammo = $weapondata::AK74::magsize;
		%a.MP5kammo = $weapondata::MP5k::magsize;
		%a.Skorpionammo = $weapondata::Skorpion::magsize;
		%a.Uziammo = $weapondata::Uzi::magsize;
		%a.M60ammo = $weapondata::M60::magsize;
		%a.RPG7ammo = $weapondata::RPG7::magsize;
		%a.pythonammo = $weapondata::python::magsize;
		%a.aspammo = $weapondata::asp::magsize;
		%a.makarovammo = $weapondata::makarov::magsize;
		%a.fastammo = 150;
		%a.rpgammo = 2;
		%a.slowammo = 50;
		%a.sniperammo=20;
		%a.PSG1ammo = $weapondata::PSG1::magsize;
		%a.Dragunovammo = $weapondata::Dragunov::magsize;
		%a.Stakeoutammo = $weapondata::Stakeout::magsize;
		%a.slugammo = 24;
		%a.M16ammo = 21;
	}
};
activatepackage(blackopsreload);