datablock ParticleData(blackopswillypeteExplosionParticle)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 20000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;

	textureName		= "base/data/particles/cloud";

	colors[0]	= "1 1 1 1";
	sizes[0]	= 25;
	times[0]	= 0.0;
};

datablock ParticleEmitterData(blackopswillypeteExplosionEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   lifeTimeMS	    = 1000;
   ejectionVelocity = 1;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false; 

   particles = "blackopswillypeteExplosionParticle";
};

datablock ExplosionData(blackopswillypeteExplosion : rocketExplosion)
{
   lifeTimeMS = 20000;
   particleEmitter = blackopswillypeteExplosionEmitter;
   shakeCamera = false;
   impulseRadius = 10;
   impulseForce =  1300;
   damageRadius = 10;
   radiusDamage = 25;
   lightStartRadius = 0;
   lightEndRadius = 0;
};

datablock ProjectileData(blackopswillypeteProjectile)
{
   projectileShapeName = "./willyprojectile.dts";
   directDamage        = 0;
   impactImpulse	   = 200;
   verticalImpulse	   = 200;
   explosion           = blackopswillypeteExplosion;

   muzzleVelocity      = 30;
   velInheritFactor    = 0;
   explodeOnDeath = true;

   armingDelay         = 5000; 
   lifetime            = 5000;
   fadeDelay           = 6000;
   bounceElasticity    = 0.4;
   bounceFriction      = 0.3;
   isBallistic         = true;
   gravityMod = 1.0;
};

datablock ItemData(blackopswillypeteItem)
{
	category = "Weapon";
	className = "Weapon";
	shapeFile = "./willypete.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Willy Pete";
	image = blackopswillypeteImage;
	canDrop = true;
	iconName = "./willypeteicon";
};

datablock ShapeBaseImageData(blackopswillypeteImage)
{
   // Basic Item properties
   shapeFile = "./willypete.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = blackopswillypeteItem;
   ammo = " ";
   projectile = blackopswillypeteProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Pindrop";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Pindrop";
	stateTransitionOnTimeout[2]	= "Pinfallen";
	stateAllowImageChange[2]	= false;
	stateTimeoutValue[2]		= 0.2;
	stateSound[2]			= blackopsFireSound;
	stateSequence[2]                = "Pinpull";

	stateName[3]			= "Pinfallen";
	stateTransitionOnTriggerDown[3]	= "Charge";
	stateAllowImageChange[3]	= false;
	
	stateName[4]                    = "Charge";
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.7;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "AbortCharge";
	stateScript[4]                  = "onCharge";
	stateAllowImageChange[4]        = false;
	
	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "Pinfallen";
	stateTimeoutValue[5]		= 0.3;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Armed";
	stateTransitionOnTriggerUp[6]	= "Fire";
	stateAllowImageChange[6]	= false;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Done";
	stateTimeoutValue[7]		= 0.5;
	stateFire[7]			= true;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Done";
	stateScript[8]					= "onDone";

};


function blackopswillypeteImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastwilly = %obj.currTool;
}

function blackopswillypeteImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function blackopswillypeteProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(!%obj.noclick)
		serverPlay3D(blackopsBounceSound,%obj.getTransform());
}

function blackopswillypeteImage::onFire(%this, %obj, %slot)
{
	Parent::OnFire(%this, %obj, %slot);
	%obj.tool[%obj.lastwilly] = 0;
	messageClient(%obj.client,'MsgItemPickup','',%obj.lastwilly,0);
	serverCmdUnUseTool(%obj.client);
}

function blackopswillypeteprojectile::onExplode(%this,%obj)
{
	if(%obj.gen<7)
	{
		%p = new Projectile()
		{
			datablock = blackopswillypeteprojectile;
			initialPosition = %obj.position;
			gen = %obj.gen+1;
			noclick = true;
		};
		missioncleanup.add(%p);
	}

	%obj.noclick = true;

	parent::onExplode(%this, %obj);
}
